DEFINT A-Z
VIEW PRINT
CLS
LOCATE 1, 18, 1
COLOR 9
PRINT "EASTER SUNDAY DATE CALCULATOR (1583 - 4099)"
FromHere:
VIEW PRINT 3 TO 24
COLOR 14
CLS
GOSUB Prompt1
LOCATE 3, 2
COLOR 2
PRINT "STARTING FROM This 4-Digit Year ( 1583 &  4099): ";
COLOR 14
LINE INPUT ; FromYear$
FromYear$ = LTRIM$(RTRIM$(FromYear$))
IF FromYear$ = "" THEN
    VIEW PRINT
    COLOR 7
    CLS
    SYSTEM
ELSEIF LEFT$(FromYear$, 1) = "0" OR LEN(FromYear$) <> 4 THEN
    RUN
END IF
FromYear = VAL(FromYear$)
IF FromYear < 1583 OR Year > 4099 THEN
    RUN
END IF
ToHere:
VIEW PRINT 6 TO 24
CLS
GOSUB Prompt2
LOCATE 6, 2
COLOR 2
PRINT "ENDING AT This 4-Digit Year ( "; FromYear$; " &  4099): ";
COLOR 14
LINE INPUT ; ToYear$
ToYear$ = LTRIM$(RTRIM$(ToYear$))
IF ToYear$ = "" THEN
    GOTO FromHere
ELSEIF LEFT$(ToYear$, 1) = "0" OR LEN(ToYear$) <> 4 THEN
    GOTO ToHere
END IF
ToYear = VAL(ToYear$)
IF ToYear < FromYear OR ToYear > 4099 THEN
    GOTO ToHere
END IF
IF FromYear = ToYear THEN
    VIEW PRINT 18 TO 24
    CLS
    LOCATE 18, 19
    COLOR 2
    PRINT "Easter Sunday: ";
    COLOR 14
ELSE
    VIEW PRINT 9 TO 24
    CLS
END IF
Count = 0
FOR Year = FromYear TO ToYear
    Count = Count + 1
    IF Count = 7 THEN
        Count = 1
        PRINT
        IF CSRLIN = 23 THEN
            GOSUB SeeMore
            IF NoMore THEN
                RUN
            END IF
        END IF
    END IF
    Year$ = MID$(STR$(Year), 2)
    GOSUB Compute
    IF Count = 1 AND FromYear < ToYear THEN
        LOCATE CSRLIN, 2
    END IF
    PRINT "0";
    IF Month = 4 THEN
        PRINT "4";
    ELSE
        PRINT "3";
    END IF
    PRINT "/";
    Day$ = MID$(STR$(Day), 2)
    IF LEN(Day$) = 1 THEN
        PRINT "0";
    END IF
    PRINT Day$; "/"; Year$; SPC(2);
    IF FromYear = ToYear THEN
        COLOR 2
        PRINT "(";
        COLOR 14
        IF Month = 3 THEN
            PRINT "March";
        ELSE
            PRINT "April";
        END IF
        PRINT SPC(1); Day$; ","; SPC(1); Year$;
        COLOR 2
        PRINT ")"
        EXIT FOR
    END IF
NEXT Year
COLOR 14
LOCATE 24, 40, 1

'wait for any key to restart
WHILE INKEY$ = ""
    _LIMIT 25
WEND
RUN

Compute:
' code from: https://www.assa.org.au/edm

FirstDig = Year \ 100 'first 2 digits of year
Remain19 = Year MOD 19 'remainder of year / 19

' calculate PFM date
temp = (FirstDig - 15) \ 2 + 202 - 11 * Remain19

SELECT CASE FirstDig
    CASE 21, 24, 25, 27 TO 32, 34, 35, 38
        temp = temp - 1
    CASE 33, 36, 37, 39, 40
        temp = temp - 2
END SELECT

temp = temp MOD 30
tA = temp + 21
IF temp = 29 THEN tA = tA - 1
IF (temp = 28 AND Remain19 > 10) THEN tA = tA - 1

' find the next Sunday
tB = (tA - 19) MOD 7
tC = (40 - FirstDig) MOD 4
IF tC = 3 THEN tC = tC + 1
IF tC > 1 THEN tC = tC + 1

temp = Year MOD 100
tD = (temp + temp \ 4) MOD 7
tE = ((20 - tB - tC - tD) MOD 7) + 1
Day = tA + tE

' return the date
IF Day > 31 THEN
    Day = Day - 31
    Month = 4
ELSE
    Month = 3
END IF
RETURN

Prompt1:
LOCATE 24, 30
COLOR 7
PRINT "Hit ";
COLOR 23
PRINT "<Enter>";
COLOR 7
PRINT " to Quit";
RETURN
Prompt2:
LOCATE 24, 29
COLOR 7
PRINT "Hit ";
COLOR 23
PRINT "<Enter>";
COLOR 7
PRINT " to Go Back";
RETURN
SeeMore:
VIEW PRINT 24 TO 24
CLS
LOCATE 24, 14, 0
COLOR 7
PRINT "Hit ";
COLOR 23
PRINT "<Esc>";
COLOR 7
PRINT " to Restart OR ";
COLOR 23
PRINT "<Any Other Key>";
COLOR 7
PRINT " to Continue";
DO
    _LIMIT 25
    An$ = INKEY$
    IF LEN(An$) THEN
        IF An$ = CHR$(27) THEN
            NoMore = -1
        ELSE
            VIEW PRINT 9 TO 24
            COLOR 14
            CLS
        END IF
        EXIT DO
    END IF
LOOP
RETURN


